<?php

	function readConfig( $path )
	{
		$file = file( $path );
		array_shift( $file );
		array_pop( $file );
		$config = array();

		foreach ( $file as $number => $line )
		{
			if ( trim( $line ) && $line[0] != ';' )
			{
				$directive = explode( '=', $line );
				$field = trim( $directive[0] );
				$value = trim( str_replace( '"', '', $directive[1]) );
				$config[ $field ] = $value;
			}
		}

		return $config;
	}

	$my_dir = explode( '/', dirname(__FILE__) );
	array_splice( $my_dir, -3 );
	$pxtc_dir = implode( '/', $my_dir );
	$conf = readConfig( $pxtc_dir . '/config/config.php' );

	if ( empty( $conf['mysqlSocket'] ) && strpos( $conf['mysqlServer'], ':' ) )
	{
		list( $conf['mysqlServer'], $conf['mysqlSocket'] ) = explode( ':', $conf['mysqlServer'] );
	}
	else
	{
		$conf['mysqlSocket'] = '';
	}

	$conf['mysqlServer'] = empty( $conf['mysqlServer'] ) && ! empty( $conf['mysqlSocket'] ) ? 'localhost' : $conf['mysqlServer'];
	$conf['mysqlPort'] = empty( $conf['mysqlPort'] ) ? NULL : (int) $conf['mysqlPort'];
	$db = new mysqli( $conf['mysqlServer'], $conf['mysqlUser'], $conf['mysqlPassword'], '', $conf['mysqlPort'], $conf['mysqlSocket'] );	

	if ( ! empty( $db->connect_error ) )
	{
		die( "Could not connect to MySQL host: {$db->connect_error}\n" );
	}

	if ( ! $db->select_db( $conf['mysqlDatabase'] ) )
	{
		die( "Could not select MySQL database: {$db->error}\n" );
	}

	$table = $conf['mysqlTablePrefix'] . 'table_downloads';
	$code = $db->real_escape_string( $_GET['c'] );
	$query = "DELETE FROM $table WHERE expires < CURRENT_TIMESTAMP";
	$db->query( $query );
	$query = "SELECT `path` FROM {$table} WHERE `code` = '{$code}'";
	$result = $db->query( $query );

	if ( ! $result )
	{
		die( "Error in MySQL query\n" );
	}
	
	if ( $result->num_rows == 0 )
	{
		die( "Invalid request\n" );
	}
	
	$row = $result->fetch_assoc();
	$file = $row['path'];
	$ip = $_SERVER['REMOTE_ADDR'];
	$query = "UPDATE {$table} SET `download_ip` = '$ip', `download_ts` = NOW() WHERE `code` = '{$code}'";
	$db->query( $query );
	$db->close();

	if ( ! ini_get('safe_mode') )
	{
		set_time_limit(0);
	}

	if ( ! file_exists( $file ) )
	{
		die( 'The requested file does not exist (anymore)' );
	}
	
	$fileRef = fopen( $file,'rb' );
	
	if ( ! $fileRef )
	{
		die( 'The requested file could not be read' );
	}
	
	header( 'Content-Description: File Transfer' );
	header( 'Content-Type: application/octet-stream' );
	header( 'Content-Disposition: attachment; filename="' . basename( $file ) . '"' );
	header( 'Content-Transfer-Encoding: binary' );
	header( 'Expires: 0' );
	header( 'Cache-Control: must-revalidate, post-check=0, pre-check=0' );
	header( 'Pragma: public' );
	header( 'Content-Length: ' . filesize( $file ) );

	while ( ! feof( $fileRef ) )
	{
		print( fread( $fileRef, 1024*8 ) );
		flush();

		if ( connection_status()!=0 )
		{
			fclose( $fileRef );
			die( 'Connection aborted by user or timed out' );
		}
	}

	fclose( $fileRef );

?>